.Dd December 14, 2024
.Os libautomation
.Dt ATMMODBUSD 1
.Sh NAME
.Nm atmmodbusd
.Nd Link a Modbus-RTU network with libautomation
.Sh SYNOPSIS
.Nm atmmodbusd
.Ar configfile
.Sh DESCRIPTION
Periodically polls registers on the Modbus network and writes the values
to a libautomation shared memory domain. The filename of
.Ar configfile
is used as id of the shared memory region.
.Pp
For writing to Modbus registers a set of named pipes is created: One for each
register. Any process might write to these FIFOs in any format that is
parseable by
.Xr strtol 3
and the value will be transmitted as soon as possible.
.Pp
atmmodbusd tries to be smart about timeouts and I/O errors. Failed requests
are retried without blocking the bus or the application while dropping
obsolete output requests. But this also means that transmission order is not
guaranteed.
.Sh CONFIGURATION
The file passed as first and only argument is read as sequentially interpreted
statements. Each statement starts with a keyword followed by tab or space
separated arguments and terminated by a newline character.
.Pp
Empty lines and lines beginning with '#' are ignored.
.Pp
Many statements use register addresses
.Ad addr
of the form <slave:reg[s][*factor]> where
.Ar slave
is the device id on the bus,
.Ar reg
is the register number on the slave,
.Li s
if present indicates, that the value shall be treated as signed, and
.Ar factor
provides optional scaling: Libautomation values are divided by
.Ar factor
before writing them to the 16-bit Modbus registers. When reading from Modbus
the register values are multiplied with
.Ar factor
before committing them to shared memory.
.Ss Global keywords
These keywords should be used a most once:
.Bl -tag
.It Ic rtu Ar device
Use TTY
.Ar device
with baudrate 9600, 8 data bits, no parity bit and 2 stop bits to attach to
the bus.
.It Ic interval Ar seconds
How often the bus is polled for updates.
.It Ic txenable Ar path
Path to a sysfs GPIO interface like pseudofile, that controls TX mode of the
bus interface.
.It Ic rxenable Ar path
Like
.Ic txenable
.It Ic stdbase Ar prefix
Default prefix to use for creating FIFOs for output.
.It Ic uptime4 Ad addr
Periodically write the current uptime of the system in minutes to register
.Ad addr
using the Modbus function code 0x04 (read input registers).
.It Ic debug
Enable
.Lb libmodbus
debug logging.
.El

.Ss Repeating keywords
.Bl -tag
.It Ic group
Creates a new group for inputs. (Data source group in libautomation terms.)
If reading a register fails, the entire rest of the group is skipped in the
polling cycle. In the next polling cycle iterating over the inputs of the
group will continue after the failed register.
.Pp
Usually one would create one group per device on the bus to
ensure that a device going offline doesn't cause long delays for everybody
due to accumulating timeouts.
.Pp
All inputs after the
.Ic group
statement until the next one are added to the group.
.It Ic input Ar key Ad addr
Use the Modbus funtion code 0x03 (read holding registers) to read from
.Ad addr
and store it in shared memory under
.Ar key .
.It Ic input4 Ar key Ad addr
As above, but use Modbus function code 0x04 (read input registers).
.It Ic input32 Ar key Ad addr
Like
.Ic input
but read two 16-bit registers and combine them into a 32-bit libautomation
value.
.It Ic output Ad addr Ar name
Create
.Ar name
as FIFO and watch it for input. Write any received data to
.Ad addr .
.It Ic both Ar key Ad addr
Combination of
.Ic input
and
.Ic output
with
.Ar key
also used as the name for the FIFO.
.El
